/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.api;

import io.micronaut.http.annotation.*;
import io.micronaut.core.annotation.*;
import io.micronaut.http.client.annotation.Client;
import io.micronaut.core.convert.format.Format;
import reactor.core.publisher.Mono;
import example.twitter.model.AddOrDeleteRulesRequest;
import example.twitter.model.AddOrDeleteRulesResponse;
import example.twitter.model.Error;
import example.twitter.model.FilteredStreamingTweet;
import example.twitter.model.GenericTweetsTimelineResponse;
import example.twitter.model.GetRules200Response;
import example.twitter.model.Granularity;
import example.twitter.model.HideReplyById200Response;
import example.twitter.model.HideReplyByIdRequest;
import example.twitter.model.MultiTweetLookupResponse;
import java.time.OffsetDateTime;
import example.twitter.model.Problem;
import java.util.Set;
import example.twitter.model.SingleTweetLookupResponse;
import example.twitter.model.StreamingTweet;
import example.twitter.model.TweetCountsResponse;
import example.twitter.model.TweetSearchResponse;
import example.twitter.model.UsersIdLikedTweets200Response;
import example.twitter.model.UsersLikesCreateRequest;
import example.twitter.model.UsersLikesCreateResponse;
import example.twitter.model.UsersLikesDeleteResponse;
import example.twitter.model.UsersRetweetsCreateRequest;
import example.twitter.model.UsersRetweetsCreateResponse;
import example.twitter.model.UsersRetweetsDeleteResponse;
import javax.annotation.Generated;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.validation.Valid;
import javax.validation.constraints.*;

@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:46.213194Z[Etc/UTC]")
@Client("${openapi-micronaut-client-base-path}")
public interface TweetsApi {
    /**
     * Add/Delete rules
     * Add or delete rules from a user&#39;s active rule set. Users can provide unique, optionally tagged rules to add. Users can delete their entire rule set or a subset specified by rule ids or values.
     *
     * @param addOrDeleteRulesRequest  (required)
     * @param dryRun Dry Run can be used with both the add and delete action, with the expected result given, but without actually taking any action in the system (meaning the end state will always be as it was when the request was submitted). This is particularly useful to validate rule changes. (optional)
     * @return AddOrDeleteRulesResponse
     */
    @Post(uri="/2/tweets/search/stream/rules")
    @Consumes({"application/json", "application/problem+json"})
    @Produces({"application/json"})
    Mono<AddOrDeleteRulesResponse> addOrDeleteRules(
        @Body @NotNull @Valid AddOrDeleteRulesRequest addOrDeleteRulesRequest, 
        @QueryValue(value="dry_run") @Nullable Boolean dryRun
    );

    /**
     * Tweet lookup by Tweet ID
     * Returns a variety of information about the Tweet specified by the requested ID
     *
     * @param id A single Tweet ID. (required)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @return SingleTweetLookupResponse
     */
    @Get(uri="/2/tweets/{id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<SingleTweetLookupResponse> findTweetById(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields
    );

    /**
     * Tweet lookup by Tweet IDs
     * Returns a variety of information about the Tweet specified by the requested ID
     *
     * @param ids A comma separated list of Tweet IDs. Up to 100 are allowed in a single request. (required)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @return MultiTweetLookupResponse
     */
    @Get(uri="/2/tweets")
    @Consumes({"application/json", "application/problem+json"})
    Mono<MultiTweetLookupResponse> findTweetsById(
        @QueryValue(value="ids") @NotNull @Size(min=1, max=100) List<String> ids, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields
    );

    /**
     * Rules lookup
     * Returns rules from a user&#39;s active rule set. Users can fetch all of their rules or a subset, specified by the provided rule ids.
     *
     * @param ids A comma-separated list of Rule IDs. (optional)
     * @return GetRules200Response
     */
    @Get(uri="/2/tweets/search/stream/rules")
    @Consumes({"application/json", "application/problem+json"})
    Mono<GetRules200Response> getRules(
        @QueryValue(value="ids") @Nullable List<String> ids
    );

    /**
     * Hide replies
     * Hides or unhides a reply to an owned conversation.
     *
     * @param id The ID of the reply that you want to hide or unhide. (required)
     * @param hideReplyByIdRequest  (optional)
     * @return HideReplyById200Response
     */
    @Put(uri="/2/tweets/{id}/hidden")
    @Consumes({"application/json", "application/problem+json"})
    @Produces({"application/json"})
    Mono<HideReplyById200Response> hideReplyById(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @Body @Nullable @Valid HideReplyByIdRequest hideReplyByIdRequest
    );

    /**
     * Sample stream
     * Streams a deterministic 1% of public Tweets.
     *
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @param backfillMinutes The number of minutes of backfill requested (optional)
     * @return StreamingTweet
     */
    @Get(uri="/2/tweets/sample/stream")
    @Consumes({"application/json", "application/problem+json"})
    Mono<StreamingTweet> sampleStream(
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields, 
        @QueryValue(value="backfill_minutes") @Nullable @Min(0) @Max(5) Integer backfillMinutes
    );

    /**
     * Filtered stream
     * Streams Tweets matching the stream&#39;s active rule set.
     *
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @param backfillMinutes The number of minutes of backfill requested (optional)
     * @return FilteredStreamingTweet
     */
    @Get(uri="/2/tweets/search/stream")
    @Consumes({"application/json", "application/problem+json"})
    Mono<FilteredStreamingTweet> searchStream(
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields, 
        @QueryValue(value="backfill_minutes") @Nullable @Min(0) @Max(5) Integer backfillMinutes
    );

    /**
     * Full archive search counts
     * Returns Tweet Counts that match a search query.
     *
     * @param query One query/rule/filter for matching Tweets. Up to 2048 characters. (required)
     * @param startTime YYYY-MM-DDTHH:mm:ssZ. The oldest UTC timestamp (from most recent 7 days) from which the Tweets will be provided. Timestamp is in second granularity and is inclusive (i.e. 12:00:01 includes the first second of the minute). (optional)
     * @param endTime YYYY-MM-DDTHH:mm:ssZ. The newest, most recent UTC timestamp to which the Tweets will be provided. Timestamp is in second granularity and is exclusive (i.e. 12:00:01 excludes the first second of the minute). (optional)
     * @param sinceId Returns results with a Tweet ID greater than (that is, more recent than) the specified ID. (optional)
     * @param untilId Returns results with a Tweet ID less than (that is, older than) the specified ID. (optional)
     * @param nextToken This parameter is used to get the next &#39;page&#39; of results. The value used with the parameter is pulled directly from the response provided by the API, and should not be modified. (optional)
     * @param granularity The granularity for the search counts results. (optional, default to hour)
     * @return TweetCountsResponse
     */
    @Get(uri="/2/tweets/counts/all")
    @Consumes({"application/json", "application/problem+json"})
    Mono<TweetCountsResponse> tweetCountsFullArchiveSearch(
        @QueryValue(value="query") @NotNull @Size(min=1, max=2048) String query, 
        @QueryValue(value="start_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime startTime, 
        @QueryValue(value="end_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime endTime, 
        @QueryValue(value="since_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String sinceId, 
        @QueryValue(value="until_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String untilId, 
        @QueryValue(value="next_token") @Nullable @Size(min=1) String nextToken, 
        @QueryValue(value="granularity", defaultValue="hour") @Nullable Granularity granularity
    );

    /**
     * Recent search counts
     * Returns Tweet Counts from the last 7 days that match a search query.
     *
     * @param query One query/rule/filter for matching Tweets. Up to 2048 characters. (required)
     * @param startTime YYYY-MM-DDTHH:mm:ssZ. The oldest UTC timestamp (from most recent 7 days) from which the Tweets will be provided. Timestamp is in second granularity and is inclusive (i.e. 12:00:01 includes the first second of the minute). (optional)
     * @param endTime YYYY-MM-DDTHH:mm:ssZ. The newest, most recent UTC timestamp to which the Tweets will be provided. Timestamp is in second granularity and is exclusive (i.e. 12:00:01 excludes the first second of the minute). (optional)
     * @param sinceId Returns results with a Tweet ID greater than (that is, more recent than) the specified ID. (optional)
     * @param untilId Returns results with a Tweet ID less than (that is, older than) the specified ID. (optional)
     * @param nextToken This parameter is used to get the next &#39;page&#39; of results. The value used with the parameter is pulled directly from the response provided by the API, and should not be modified. (optional)
     * @param granularity The granularity for the search counts results. (optional, default to hour)
     * @return TweetCountsResponse
     */
    @Get(uri="/2/tweets/counts/recent")
    @Consumes({"application/json", "application/problem+json"})
    Mono<TweetCountsResponse> tweetCountsRecentSearch(
        @QueryValue(value="query") @NotNull @Size(min=1, max=2048) String query, 
        @QueryValue(value="start_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime startTime, 
        @QueryValue(value="end_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime endTime, 
        @QueryValue(value="since_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String sinceId, 
        @QueryValue(value="until_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String untilId, 
        @QueryValue(value="next_token") @Nullable @Size(min=1) String nextToken, 
        @QueryValue(value="granularity", defaultValue="hour") @Nullable Granularity granularity
    );

    /**
     * Full-archive search
     * Returns Tweets that match a search query.
     *
     * @param query One query/rule/filter for matching Tweets. Up to 1024 characters. (required)
     * @param startTime YYYY-MM-DDTHH:mm:ssZ. The oldest UTC timestamp from which the Tweets will be provided. Timestamp is in second granularity and is inclusive (i.e. 12:00:01 includes the first second of the minute). (optional)
     * @param endTime YYYY-MM-DDTHH:mm:ssZ. The newest, most recent UTC timestamp to which the Tweets will be provided. Timestamp is in second granularity and is exclusive (i.e. 12:00:01 excludes the first second of the minute). (optional)
     * @param sinceId Returns results with a Tweet ID greater than (that is, more recent than) the specified ID. (optional)
     * @param untilId Returns results with a Tweet ID less than (that is, older than) the specified ID. (optional)
     * @param maxResults The maximum number of search results to be returned by a request. (optional, default to 10)
     * @param nextToken This parameter is used to get the next &#39;page&#39; of results. The value used with the parameter is pulled directly from the response provided by the API, and should not be modified. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @return TweetSearchResponse
     */
    @Get(uri="/2/tweets/search/all")
    @Consumes({"application/json", "application/problem+json"})
    Mono<TweetSearchResponse> tweetsFullarchiveSearch(
        @QueryValue(value="query") @NotNull @Size(min=1, max=1024) String query, 
        @QueryValue(value="start_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime startTime, 
        @QueryValue(value="end_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime endTime, 
        @QueryValue(value="since_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String sinceId, 
        @QueryValue(value="until_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String untilId, 
        @QueryValue(value="max_results", defaultValue="10") @Nullable @Min(10) @Max(500) Integer maxResults, 
        @QueryValue(value="next_token") @Nullable @Size(min=1) String nextToken, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields
    );

    /**
     * Recent search
     * Returns Tweets from the last 7 days that match a search query.
     *
     * @param query One query/rule/filter for matching Tweets. Up to 512 characters. (required)
     * @param startTime YYYY-MM-DDTHH:mm:ssZ. The oldest UTC timestamp (from most recent 7 days) from which the Tweets will be provided. Timestamp is in second granularity and is inclusive (i.e. 12:00:01 includes the first second of the minute). (optional)
     * @param endTime YYYY-MM-DDTHH:mm:ssZ. The newest, most recent UTC timestamp to which the Tweets will be provided. Timestamp is in second granularity and is exclusive (i.e. 12:00:01 excludes the first second of the minute). (optional)
     * @param sinceId Returns results with a Tweet ID greater than (that is, more recent than) the specified ID. (optional)
     * @param untilId Returns results with a Tweet ID less than (that is, older than) the specified ID. (optional)
     * @param maxResults The maximum number of search results to be returned by a request. (optional, default to 10)
     * @param nextToken This parameter is used to get the next &#39;page&#39; of results. The value used with the parameter is pulled directly from the response provided by the API, and should not be modified. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @return TweetSearchResponse
     */
    @Get(uri="/2/tweets/search/recent")
    @Consumes({"application/json", "application/problem+json"})
    Mono<TweetSearchResponse> tweetsRecentSearch(
        @QueryValue(value="query") @NotNull @Size(min=1, max=512) String query, 
        @QueryValue(value="start_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime startTime, 
        @QueryValue(value="end_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime endTime, 
        @QueryValue(value="since_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String sinceId, 
        @QueryValue(value="until_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String untilId, 
        @QueryValue(value="max_results", defaultValue="10") @Nullable @Min(10) @Max(100) Integer maxResults, 
        @QueryValue(value="next_token") @Nullable @Size(min=1) String nextToken, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields
    );

    /**
     * Causes the user (in the path) to like the specified tweet
     * Causes the user (in the path) to like the specified tweet. The user in the path must match the user context authorizing the request.
     *
     * @param id The ID of the user that is requesting to like the tweet (required)
     * @param usersLikesCreateRequest  (optional)
     * @return UsersLikesCreateResponse
     */
    @Post(uri="/2/users/{id}/likes")
    @Consumes({"application/json", "application/problem+json"})
    @Produces({"application/json"})
    Mono<UsersLikesCreateResponse> usersIdLike(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @Body @Nullable @Valid UsersLikesCreateRequest usersLikesCreateRequest
    );

    /**
     * Returns Tweet objects liked by the provided User ID
     * Returns a list of Tweets liked by the provided User ID
     *
     * @param id The ID of the User to list the liked Tweets of (required)
     * @param maxResults The maximum number of results (optional)
     * @param paginationToken This parameter is used to get the next &#39;page&#39; of results. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @return UsersIdLikedTweets200Response
     */
    @Get(uri="/2/users/{id}/liked_tweets")
    @Consumes({"application/json", "application/problem+json"})
    Mono<UsersIdLikedTweets200Response> usersIdLikedTweets(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="max_results") @Nullable @Min(5) @Max(100) Integer maxResults, 
        @QueryValue(value="pagination_token") @Nullable @Size(min=1) String paginationToken, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields
    );

    /**
     * User mention timeline by User ID
     * Returns Tweet objects that mention username associated to the provided User ID
     *
     * @param id The ID of the User to list mentions of (required)
     * @param sinceId The minimum Tweet ID to be included in the result set. This parameter takes precedence over start_time if both are specified. (optional)
     * @param untilId The maximum Tweet ID to be included in the result set. This parameter takes precedence over end_time if both are specified. (optional)
     * @param maxResults The maximum number of results (optional)
     * @param paginationToken This parameter is used to get the next &#39;page&#39; of results. (optional)
     * @param startTime YYYY-MM-DDTHH:mm:ssZ. The earliest UTC timestamp from which the Tweets will be provided. The since_id parameter takes precedence if it is also specified. (optional)
     * @param endTime YYYY-MM-DDTHH:mm:ssZ. The latest UTC timestamp to which the Tweets will be provided. The until_id parameter takes precedence if it is also specified. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @return GenericTweetsTimelineResponse
     */
    @Get(uri="/2/users/{id}/mentions")
    @Consumes({"application/json", "application/problem+json"})
    Mono<GenericTweetsTimelineResponse> usersIdMentions(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="since_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String sinceId, 
        @QueryValue(value="until_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String untilId, 
        @QueryValue(value="max_results") @Nullable @Min(5) @Max(100) Integer maxResults, 
        @QueryValue(value="pagination_token") @Nullable @Size(min=1) String paginationToken, 
        @QueryValue(value="start_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime startTime, 
        @QueryValue(value="end_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime endTime, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields
    );

    /**
     * Causes the user (in the path) to retweet the specified tweet
     * Causes the user (in the path) to retweet the specified tweet. The user in the path must match the user context authorizing the request.
     *
     * @param id The ID of the user that is requesting to retweet the tweet (required)
     * @param usersRetweetsCreateRequest  (optional)
     * @return UsersRetweetsCreateResponse
     */
    @Post(uri="/2/users/{id}/retweets")
    @Consumes({"application/json", "application/problem+json"})
    @Produces({"application/json"})
    Mono<UsersRetweetsCreateResponse> usersIdRetweets(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @Body @Nullable @Valid UsersRetweetsCreateRequest usersRetweetsCreateRequest
    );

    /**
     * User Tweets timeline by User ID
     * Returns a list of Tweets authored by the provided User ID
     *
     * @param id The ID of the User to list Tweets of (required)
     * @param sinceId The minimum Tweet ID to be included in the result set. This parameter takes precedence over start_time if both are specified. (optional)
     * @param untilId The maximum Tweet ID to be included in the result set. This parameter takes precedence over end_time if both are specified. (optional)
     * @param maxResults The maximum number of results (optional)
     * @param exclude The set of entities to exclude (e.g. &#39;replies&#39; or &#39;retweets&#39;) (optional)
     * @param paginationToken This parameter is used to get the next &#39;page&#39; of results. (optional)
     * @param startTime YYYY-MM-DDTHH:mm:ssZ. The earliest UTC timestamp from which the Tweets will be provided. The since_id parameter takes precedence if it is also specified. (optional)
     * @param endTime YYYY-MM-DDTHH:mm:ssZ. The latest UTC timestamp to which the Tweets will be provided. The until_id parameter takes precedence if it is also specified. (optional)
     * @param expansions A comma separated list of fields to expand. (optional)
     * @param tweetFields A comma separated list of Tweet fields to display. (optional)
     * @param userFields A comma separated list of User fields to display. (optional)
     * @param mediaFields A comma separated list of Media fields to display. (optional)
     * @param placeFields A comma separated list of Place fields to display. (optional)
     * @param pollFields A comma separated list of Poll fields to display. (optional)
     * @return GenericTweetsTimelineResponse
     */
    @Get(uri="/2/users/{id}/tweets")
    @Consumes({"application/json", "application/problem+json"})
    Mono<GenericTweetsTimelineResponse> usersIdTweets(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @QueryValue(value="since_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String sinceId, 
        @QueryValue(value="until_id") @Nullable @Pattern(regexp="^[0-9]{1,19}$") String untilId, 
        @QueryValue(value="max_results") @Nullable @Min(5) @Max(100) Integer maxResults, 
        @QueryValue(value="exclude") @Nullable @Size(min=1) Set<String> exclude, 
        @QueryValue(value="pagination_token") @Nullable @Size(min=1) String paginationToken, 
        @QueryValue(value="start_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime startTime, 
        @QueryValue(value="end_time") @Nullable @Format("yyyy-MM-dd'T'HH:mm:ss.SSSXXXX") OffsetDateTime endTime, 
        @QueryValue(value="expansions") @Nullable @Size(min=1) Set<String> expansions, 
        @QueryValue(value="tweet.fields") @Nullable @Size(min=1) Set<String> tweetFields, 
        @QueryValue(value="user.fields") @Nullable @Size(min=1) Set<String> userFields, 
        @QueryValue(value="media.fields") @Nullable @Size(min=1) Set<String> mediaFields, 
        @QueryValue(value="place.fields") @Nullable @Size(min=1) Set<String> placeFields, 
        @QueryValue(value="poll.fields") @Nullable @Size(min=1) Set<String> pollFields
    );

    /**
     * Causes the user (in the path) to unlike the specified tweet
     * Causes the user (in the path) to unlike the specified tweet. The user must match the user context authorizing the request
     *
     * @param id The ID of the user that is requesting to unlike the tweet (required)
     * @param tweetId The ID of the tweet that the user is requesting to unlike (required)
     * @return UsersLikesDeleteResponse
     */
    @Delete(uri="/2/users/{id}/likes/{tweet_id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<UsersLikesDeleteResponse> usersIdUnlike(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @PathVariable(name="tweet_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String tweetId
    );

    /**
     * Causes the user (in the path) to unretweet the specified tweet
     * Causes the user (in the path) to unretweet the specified tweet. The user must match the user context authorizing the request
     *
     * @param id The ID of the user that is requesting to unretweet the tweet (required)
     * @param sourceTweetId The ID of the tweet that the user is requesting to unretweet (required)
     * @return UsersRetweetsDeleteResponse
     */
    @Delete(uri="/2/users/{id}/retweets/{source_tweet_id}")
    @Consumes({"application/json", "application/problem+json"})
    Mono<UsersRetweetsDeleteResponse> usersIdUnretweets(
        @PathVariable(name="id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String id, 
        @PathVariable(name="source_tweet_id") @NotNull @Pattern(regexp="^[0-9]{1,19}$") String sourceTweetId
    );

}
