/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import example.twitter.model.AnimatedGifAllOf;
import example.twitter.model.CommonMediaFields;
import java.net.URI;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * AnimatedGif
 */
@JsonPropertyOrder({
  AnimatedGif.JSON_PROPERTY_HEIGHT,
  AnimatedGif.JSON_PROPERTY_MEDIA_KEY,
  AnimatedGif.JSON_PROPERTY_WIDTH,
  AnimatedGif.JSON_PROPERTY_PREVIEW_IMAGE_URL,
  AnimatedGif.JSON_PROPERTY_TYPE
})
@JsonTypeName("AnimatedGif")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:46.213194Z[Etc/UTC]")
@Introspected
public class AnimatedGif {
    public static final String JSON_PROPERTY_HEIGHT = "height";
    private Integer height;

    public static final String JSON_PROPERTY_MEDIA_KEY = "media_key";
    private String mediaKey;

    public static final String JSON_PROPERTY_WIDTH = "width";
    private Integer width;

    public static final String JSON_PROPERTY_PREVIEW_IMAGE_URL = "preview_image_url";
    private URI previewImageUrl;

    /**
     * Gets or Sets type
     */
    public enum TypeEnum {
        ANIMATED_GIF("animated_gif");

        private String value;

        TypeEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return value;
        }

        @Override
        public String toString() {
            return String.valueOf(value);
        }

        @JsonCreator
        public static TypeEnum fromValue(String value) {
            for (TypeEnum b : TypeEnum.values()) {
                if (b.value.equals(value)) {
                    return b;
                }
            }
            throw new IllegalArgumentException("Unexpected value '" + value + "'");
        }
    }
    public static final String JSON_PROPERTY_TYPE = "type";
    private TypeEnum type;

    public AnimatedGif() {
    }

    public AnimatedGif height(Integer height) {
        this.height = height;
        return this;
    }

    /**
     * The height of the media in pixels
     * minimum: 0
     * @return height
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getHeight() {
        return height;
    }

    @JsonProperty(JSON_PROPERTY_HEIGHT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setHeight(Integer height) {
        this.height = height;
    }

    public AnimatedGif mediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
        return this;
    }

    /**
     * The Media Key identifier for this attachment.
     * @return mediaKey
     **/
    @Nullable
    @Pattern(regexp="^([0-9]+)_([0-9]+)$")
    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getMediaKey() {
        return mediaKey;
    }

    @JsonProperty(JSON_PROPERTY_MEDIA_KEY)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setMediaKey(String mediaKey) {
        this.mediaKey = mediaKey;
    }

    public AnimatedGif width(Integer width) {
        this.width = width;
        return this;
    }

    /**
     * The width of the media in pixels
     * minimum: 0
     * @return width
     **/
    @Nullable
    @Min(0)
    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getWidth() {
        return width;
    }

    @JsonProperty(JSON_PROPERTY_WIDTH)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setWidth(Integer width) {
        this.width = width;
    }

    public AnimatedGif previewImageUrl(URI previewImageUrl) {
        this.previewImageUrl = previewImageUrl;
        return this;
    }

    /**
     * Get previewImageUrl
     * @return previewImageUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_PREVIEW_IMAGE_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getPreviewImageUrl() {
        return previewImageUrl;
    }

    @JsonProperty(JSON_PROPERTY_PREVIEW_IMAGE_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setPreviewImageUrl(URI previewImageUrl) {
        this.previewImageUrl = previewImageUrl;
    }

    public AnimatedGif type(TypeEnum type) {
        this.type = type;
        return this;
    }

    /**
     * Get type
     * @return type
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public TypeEnum getType() {
        return type;
    }

    @JsonProperty(JSON_PROPERTY_TYPE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setType(TypeEnum type) {
        this.type = type;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        AnimatedGif animatedGif = (AnimatedGif) o;
        return Objects.equals(this.height, animatedGif.height) &&
            Objects.equals(this.mediaKey, animatedGif.mediaKey) &&
            Objects.equals(this.width, animatedGif.width) &&
            Objects.equals(this.previewImageUrl, animatedGif.previewImageUrl) &&
            Objects.equals(this.type, animatedGif.type);
    }

    @Override
    public int hashCode() {
        return Objects.hash(height, mediaKey, width, previewImageUrl, type);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class AnimatedGif {\n");
        sb.append("    height: ").append(toIndentedString(height)).append("\n");
        sb.append("    mediaKey: ").append(toIndentedString(mediaKey)).append("\n");
        sb.append("    width: ").append(toIndentedString(width)).append("\n");
        sb.append("    previewImageUrl: ").append(toIndentedString(previewImageUrl)).append("\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
