/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * Promoted nonpublic engagement metrics for the Tweet at the time of the request.
 */
@JsonPropertyOrder({
  TweetPromotedMetrics.JSON_PROPERTY_IMPRESSION_COUNT,
  TweetPromotedMetrics.JSON_PROPERTY_LIKE_COUNT,
  TweetPromotedMetrics.JSON_PROPERTY_REPLY_COUNT,
  TweetPromotedMetrics.JSON_PROPERTY_RETWEET_COUNT
})
@JsonTypeName("Tweet_promoted_metrics")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:46.213194Z[Etc/UTC]")
@Introspected
public class TweetPromotedMetrics {
    public static final String JSON_PROPERTY_IMPRESSION_COUNT = "impression_count";
    private Integer impressionCount;

    public static final String JSON_PROPERTY_LIKE_COUNT = "like_count";
    private Integer likeCount;

    public static final String JSON_PROPERTY_REPLY_COUNT = "reply_count";
    private Integer replyCount;

    public static final String JSON_PROPERTY_RETWEET_COUNT = "retweet_count";
    private Integer retweetCount;

    public TweetPromotedMetrics() {
    }

    public TweetPromotedMetrics impressionCount(Integer impressionCount) {
        this.impressionCount = impressionCount;
        return this;
    }

    /**
     * Number of times this Tweet has been viewed.
     * @return impressionCount
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_IMPRESSION_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getImpressionCount() {
        return impressionCount;
    }

    @JsonProperty(JSON_PROPERTY_IMPRESSION_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setImpressionCount(Integer impressionCount) {
        this.impressionCount = impressionCount;
    }

    public TweetPromotedMetrics likeCount(Integer likeCount) {
        this.likeCount = likeCount;
        return this;
    }

    /**
     * Number of times this Tweet has been liked.
     * @return likeCount
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_LIKE_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getLikeCount() {
        return likeCount;
    }

    @JsonProperty(JSON_PROPERTY_LIKE_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setLikeCount(Integer likeCount) {
        this.likeCount = likeCount;
    }

    public TweetPromotedMetrics replyCount(Integer replyCount) {
        this.replyCount = replyCount;
        return this;
    }

    /**
     * Number of times this Tweet has been replied to.
     * @return replyCount
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_REPLY_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getReplyCount() {
        return replyCount;
    }

    @JsonProperty(JSON_PROPERTY_REPLY_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setReplyCount(Integer replyCount) {
        this.replyCount = replyCount;
    }

    public TweetPromotedMetrics retweetCount(Integer retweetCount) {
        this.retweetCount = retweetCount;
        return this;
    }

    /**
     * Number of times this Tweet has been Retweeted.
     * @return retweetCount
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_RETWEET_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getRetweetCount() {
        return retweetCount;
    }

    @JsonProperty(JSON_PROPERTY_RETWEET_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setRetweetCount(Integer retweetCount) {
        this.retweetCount = retweetCount;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        TweetPromotedMetrics tweetPromotedMetrics = (TweetPromotedMetrics) o;
        return Objects.equals(this.impressionCount, tweetPromotedMetrics.impressionCount) &&
            Objects.equals(this.likeCount, tweetPromotedMetrics.likeCount) &&
            Objects.equals(this.replyCount, tweetPromotedMetrics.replyCount) &&
            Objects.equals(this.retweetCount, tweetPromotedMetrics.retweetCount);
    }

    @Override
    public int hashCode() {
        return Objects.hash(impressionCount, likeCount, replyCount, retweetCount);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class TweetPromotedMetrics {\n");
        sb.append("    impressionCount: ").append(toIndentedString(impressionCount)).append("\n");
        sb.append("    likeCount: ").append(toIndentedString(likeCount)).append("\n");
        sb.append("    replyCount: ").append(toIndentedString(replyCount)).append("\n");
        sb.append("    retweetCount: ").append(toIndentedString(retweetCount)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
