/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * TweetSearchResponseMeta
 */
@JsonPropertyOrder({
  TweetSearchResponseMeta.JSON_PROPERTY_NEWEST_ID,
  TweetSearchResponseMeta.JSON_PROPERTY_NEXT_TOKEN,
  TweetSearchResponseMeta.JSON_PROPERTY_OLDEST_ID,
  TweetSearchResponseMeta.JSON_PROPERTY_RESULT_COUNT
})
@JsonTypeName("TweetSearchResponse_meta")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:46.213194Z[Etc/UTC]")
@Introspected
public class TweetSearchResponseMeta {
    public static final String JSON_PROPERTY_NEWEST_ID = "newest_id";
    private String newestId;

    public static final String JSON_PROPERTY_NEXT_TOKEN = "next_token";
    private String nextToken;

    public static final String JSON_PROPERTY_OLDEST_ID = "oldest_id";
    private String oldestId;

    public static final String JSON_PROPERTY_RESULT_COUNT = "result_count";
    private Integer resultCount;

    public TweetSearchResponseMeta() {
    }

    public TweetSearchResponseMeta newestId(String newestId) {
        this.newestId = newestId;
        return this;
    }

    /**
     * Most recent Tweet Id returned by search query
     * @return newestId
     **/
    @Nullable
    @Pattern(regexp="^[0-9]{1,19}$")
    @JsonProperty(JSON_PROPERTY_NEWEST_ID)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getNewestId() {
        return newestId;
    }

    @JsonProperty(JSON_PROPERTY_NEWEST_ID)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setNewestId(String newestId) {
        this.newestId = newestId;
    }

    public TweetSearchResponseMeta nextToken(String nextToken) {
        this.nextToken = nextToken;
        return this;
    }

    /**
     * This value is used to get the next &#39;page&#39; of results by providing it to the next_token parameter.
     * @return nextToken
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_NEXT_TOKEN)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getNextToken() {
        return nextToken;
    }

    @JsonProperty(JSON_PROPERTY_NEXT_TOKEN)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setNextToken(String nextToken) {
        this.nextToken = nextToken;
    }

    public TweetSearchResponseMeta oldestId(String oldestId) {
        this.oldestId = oldestId;
        return this;
    }

    /**
     * Oldest Tweet Id returned by search query
     * @return oldestId
     **/
    @Nullable
    @Pattern(regexp="^[0-9]{1,19}$")
    @JsonProperty(JSON_PROPERTY_OLDEST_ID)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getOldestId() {
        return oldestId;
    }

    @JsonProperty(JSON_PROPERTY_OLDEST_ID)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setOldestId(String oldestId) {
        this.oldestId = oldestId;
    }

    public TweetSearchResponseMeta resultCount(Integer resultCount) {
        this.resultCount = resultCount;
        return this;
    }

    /**
     * Number of search query results
     * @return resultCount
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_RESULT_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getResultCount() {
        return resultCount;
    }

    @JsonProperty(JSON_PROPERTY_RESULT_COUNT)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setResultCount(Integer resultCount) {
        this.resultCount = resultCount;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        TweetSearchResponseMeta tweetSearchResponseMeta = (TweetSearchResponseMeta) o;
        return Objects.equals(this.newestId, tweetSearchResponseMeta.newestId) &&
            Objects.equals(this.nextToken, tweetSearchResponseMeta.nextToken) &&
            Objects.equals(this.oldestId, tweetSearchResponseMeta.oldestId) &&
            Objects.equals(this.resultCount, tweetSearchResponseMeta.resultCount);
    }

    @Override
    public int hashCode() {
        return Objects.hash(newestId, nextToken, oldestId, resultCount);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class TweetSearchResponseMeta {\n");
        sb.append("    newestId: ").append(toIndentedString(newestId)).append("\n");
        sb.append("    nextToken: ").append(toIndentedString(nextToken)).append("\n");
        sb.append("    oldestId: ").append(toIndentedString(oldestId)).append("\n");
        sb.append("    resultCount: ").append(toIndentedString(resultCount)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
