/*
 * Twitter API v2
 * Twitter API v2 available endpoints
 *
 * The version of the OpenAPI document: 2.21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package example.twitter.model;

import java.util.Objects;
import java.util.Arrays;
import example.twitter.model.URLImage;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.*;

import javax.validation.constraints.*;
import javax.validation.Valid;
import io.micronaut.core.annotation.*;
import javax.annotation.Generated;

/**
 * Represent the portion of text recognized as a URL.
 */
@JsonPropertyOrder({
  URLFields.JSON_PROPERTY_DESCRIPTION,
  URLFields.JSON_PROPERTY_DISPLAY_URL,
  URLFields.JSON_PROPERTY_EXPANDED_URL,
  URLFields.JSON_PROPERTY_IMAGES,
  URLFields.JSON_PROPERTY_STATUS,
  URLFields.JSON_PROPERTY_TITLE,
  URLFields.JSON_PROPERTY_UNWOUND_URL,
  URLFields.JSON_PROPERTY_URL
})
@JsonTypeName("URLFields")
@Generated(value="org.openapitools.codegen.languages.JavaMicronautClientCodegen", date="2024-01-09T20:51:46.213194Z[Etc/UTC]")
@Introspected
public class URLFields {
    public static final String JSON_PROPERTY_DESCRIPTION = "description";
    private String description;

    public static final String JSON_PROPERTY_DISPLAY_URL = "display_url";
    private String displayUrl;

    public static final String JSON_PROPERTY_EXPANDED_URL = "expanded_url";
    private URI expandedUrl;

    public static final String JSON_PROPERTY_IMAGES = "images";
    private List<URLImage> images = null;

    public static final String JSON_PROPERTY_STATUS = "status";
    private Integer status;

    public static final String JSON_PROPERTY_TITLE = "title";
    private String title;

    public static final String JSON_PROPERTY_UNWOUND_URL = "unwound_url";
    private URI unwoundUrl;

    public static final String JSON_PROPERTY_URL = "url";
    private URI url;

    public URLFields(URI url) {
        this.url = url;
    }

    public URLFields description(String description) {
        this.description = description;
        return this;
    }

    /**
     * Description of the URL landing page.
     * @return description
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_DESCRIPTION)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getDescription() {
        return description;
    }

    @JsonProperty(JSON_PROPERTY_DESCRIPTION)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setDescription(String description) {
        this.description = description;
    }

    public URLFields displayUrl(String displayUrl) {
        this.displayUrl = displayUrl;
        return this;
    }

    /**
     * The URL as displayed in the Twitter client.
     * @return displayUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_DISPLAY_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getDisplayUrl() {
        return displayUrl;
    }

    @JsonProperty(JSON_PROPERTY_DISPLAY_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setDisplayUrl(String displayUrl) {
        this.displayUrl = displayUrl;
    }

    public URLFields expandedUrl(URI expandedUrl) {
        this.expandedUrl = expandedUrl;
        return this;
    }

    /**
     * A validly formatted URL.
     * @return expandedUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_EXPANDED_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getExpandedUrl() {
        return expandedUrl;
    }

    @JsonProperty(JSON_PROPERTY_EXPANDED_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setExpandedUrl(URI expandedUrl) {
        this.expandedUrl = expandedUrl;
    }

    public URLFields images(List<URLImage> images) {
        this.images = images;
        return this;
    }

    public URLFields addImagesItem(URLImage imagesItem) {
        if (this.images == null) {
            this.images = new ArrayList<>();
        }
        this.images.add(imagesItem);
        return this;
    }

    /**
     * Get images
     * @return images
     **/
    @Nullable
    @Size(min=1)
    @JsonProperty(JSON_PROPERTY_IMAGES)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public List<URLImage> getImages() {
        return images;
    }

    @JsonProperty(JSON_PROPERTY_IMAGES)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setImages(List<URLImage> images) {
        this.images = images;
    }

    public URLFields status(Integer status) {
        this.status = status;
        return this;
    }

    /**
     * HTTP Status Code.
     * minimum: 100
     * maximum: 599
     * @return status
     **/
    @Nullable
    @Min(100)
    @Max(599)
    @JsonProperty(JSON_PROPERTY_STATUS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public Integer getStatus() {
        return status;
    }

    @JsonProperty(JSON_PROPERTY_STATUS)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setStatus(Integer status) {
        this.status = status;
    }

    public URLFields title(String title) {
        this.title = title;
        return this;
    }

    /**
     * Title of the page the URL points to.
     * @return title
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_TITLE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public String getTitle() {
        return title;
    }

    @JsonProperty(JSON_PROPERTY_TITLE)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setTitle(String title) {
        this.title = title;
    }

    public URLFields unwoundUrl(URI unwoundUrl) {
        this.unwoundUrl = unwoundUrl;
        return this;
    }

    /**
     * Fully resolved url
     * @return unwoundUrl
     **/
    @Nullable
    @JsonProperty(JSON_PROPERTY_UNWOUND_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public URI getUnwoundUrl() {
        return unwoundUrl;
    }

    @JsonProperty(JSON_PROPERTY_UNWOUND_URL)
    @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
    public void setUnwoundUrl(URI unwoundUrl) {
        this.unwoundUrl = unwoundUrl;
    }

    public URLFields url(URI url) {
        this.url = url;
        return this;
    }

    /**
     * A validly formatted URL.
     * @return url
     **/
    @NotNull
    @JsonProperty(JSON_PROPERTY_URL)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public URI getUrl() {
        return url;
    }

    @JsonProperty(JSON_PROPERTY_URL)
    @JsonInclude(value = JsonInclude.Include.ALWAYS)
    public void setUrl(URI url) {
        this.url = url;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        URLFields urLFields = (URLFields) o;
        return Objects.equals(this.description, urLFields.description) &&
            Objects.equals(this.displayUrl, urLFields.displayUrl) &&
            Objects.equals(this.expandedUrl, urLFields.expandedUrl) &&
            Objects.equals(this.images, urLFields.images) &&
            Objects.equals(this.status, urLFields.status) &&
            Objects.equals(this.title, urLFields.title) &&
            Objects.equals(this.unwoundUrl, urLFields.unwoundUrl) &&
            Objects.equals(this.url, urLFields.url);
    }

    @Override
    public int hashCode() {
        return Objects.hash(description, displayUrl, expandedUrl, images, status, title, unwoundUrl, url);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class URLFields {\n");
        sb.append("    description: ").append(toIndentedString(description)).append("\n");
        sb.append("    displayUrl: ").append(toIndentedString(displayUrl)).append("\n");
        sb.append("    expandedUrl: ").append(toIndentedString(expandedUrl)).append("\n");
        sb.append("    images: ").append(toIndentedString(images)).append("\n");
        sb.append("    status: ").append(toIndentedString(status)).append("\n");
        sb.append("    title: ").append(toIndentedString(title)).append("\n");
        sb.append("    unwoundUrl: ").append(toIndentedString(unwoundUrl)).append("\n");
        sb.append("    url: ").append(toIndentedString(url)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}
